"""
    Xbim Flex Identity API 1.0

    Communication centralised around construction data  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: info@xbim.net
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from xbim_flex.identity.api_client import ApiClient, Endpoint as _Endpoint
from xbim_flex.identity.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from xbim_flex.identity.model.region_info import RegionInfo
from xbim_flex.identity.model.user import User


class MeApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.id_api_me_get_endpoint = _Endpoint(
            settings={
                'response_type': (User,),
                'auth': [
                    'oauth2'
                ],
                'endpoint_path': '/id/api/Me',
                'operation_id': 'id_api_me_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'expand',
                    'select',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'expand':
                        (str,),
                    'select':
                        (str,),
                },
                'attribute_map': {
                    'expand': '$expand',
                    'select': '$select',
                },
                'location_map': {
                    'expand': 'query',
                    'select': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json;odata.metadata=minimal;odata.streaming=true',
                    'application/json;odata.metadata=minimal;odata.streaming=false',
                    'application/json;odata.metadata=minimal',
                    'application/json;odata.metadata=full;odata.streaming=true',
                    'application/json;odata.metadata=full;odata.streaming=false',
                    'application/json;odata.metadata=full',
                    'application/json;odata.metadata=none;odata.streaming=true',
                    'application/json;odata.metadata=none;odata.streaming=false',
                    'application/json;odata.metadata=none',
                    'application/json;odata.streaming=true',
                    'application/json;odata.streaming=false',
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.id_api_me_regions_get_endpoint = _Endpoint(
            settings={
                'response_type': (RegionInfo,),
                'auth': [
                    'oauth2'
                ],
                'endpoint_path': '/id/api/Me/Regions',
                'operation_id': 'id_api_me_regions_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'expand',
                    'select',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'expand':
                        (str,),
                    'select':
                        (str,),
                },
                'attribute_map': {
                    'expand': '$expand',
                    'select': '$select',
                },
                'location_map': {
                    'expand': 'query',
                    'select': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json;odata.metadata=minimal;odata.streaming=true',
                    'application/json;odata.metadata=minimal;odata.streaming=false',
                    'application/json;odata.metadata=minimal',
                    'application/json;odata.metadata=full;odata.streaming=true',
                    'application/json;odata.metadata=full;odata.streaming=false',
                    'application/json;odata.metadata=full',
                    'application/json;odata.metadata=none;odata.streaming=true',
                    'application/json;odata.metadata=none;odata.streaming=false',
                    'application/json;odata.metadata=none',
                    'application/json;odata.streaming=true',
                    'application/json;odata.streaming=false',
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def id_api_me_get(
        self,
        **kwargs
    ):
        """Gets details of the current logged in user  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.id_api_me_get(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            expand (str): Indicates the related entities to be represented inline. The maximum depth is 2.. [optional]
            select (str): Limits the properties returned in the result.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            User
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.id_api_me_get_endpoint.call_with_http_info(**kwargs)

    def id_api_me_regions_get(
        self,
        **kwargs
    ):
        """Gets a list of regions where current user has access to any tenancy (workspace)  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.id_api_me_regions_get(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            expand (str): Indicates the related entities to be represented inline. The maximum depth is 2.. [optional]
            select (str): Limits the properties returned in the result.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            RegionInfo
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.id_api_me_regions_get_endpoint.call_with_http_info(**kwargs)

